/* ----------------------------------------------------------------------- */
/*         Fernando Berzal Galiano       ETS Ingeniera Informtica        */
/* ----------------------------------------------------------------------- */

#ifndef __DB__
#define __DB__


#include "FB_LIST.H"

/* ----------------------- */
/*  Longitudes permitidas  */
/* ----------------------- */

#define FICHERO   80
#define DATABASE  30
#define CAMPO     13
#define ENUMERADO 62
#define CAMPOMEMO 62
#define MAXCADENA 62
#define TIPO      30

/* Tamao del buffer para intercambio con ficheros */

#define BUFFER 8192

/* ----------------------------------------------------------------------- */
/*                              Tipos de Campos                            */
/* ----------------------------------------------------------------------- */

typedef enum TCampo {
		     Entero,
		     Real,
		     Enumerado,
		     Fecha,
		     Cadena,
		     MEMO,
		     Referencia,
		     SinTipo
		    } TipoCampo;

/* ----------------------------------------------------------------------- */
/*          Informacin acerca del formato de una base de datos            */
/* ----------------------------------------------------------------------- */

typedef struct DB {
		   char  fichDatos[FICHERO];
		   char  fichFormato[FICHERO];
		   char  nombre[DATABASE];
		   int   NumCampos;         /* Nmero de campos            */
		   int   dim;               /* Tamao de los registros     */
		   Lista campos;            /* Campos de los registros     */
		  } InfoDB;

typedef InfoDB *DataBase;

/* ----------------------------------------------------------------------- */
/*           Ficha correspondiente a un dato de una base de datos          */
/* ----------------------------------------------------------------------- */

typedef struct Ficha {
		       DataBase BD;
		       long     numero;
		       void    *dato;
		       void   **info;
		     };

typedef struct Ficha *Ficha;

/* ----------------------------------------------------------------------- */

#endif
