/* ----------------------------------------------------------------------- */
/*         Fernando Berzal Galiano      ETS Ingeniera Informtica         */
/* ----------------------------------------------------------------------- */
/*                    Gestor de bases de datos FBGVG                       */
/* ----------------------------------------------------------------------- */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "FBG_CRT.H"
#include "FBG_KBD.H"
#include "FBG_MENU.H"
#include "FBG_UTIL.H"
#include "FBG_DATE.H"

#include "DB.H"
#include "DB_FRM.H"
#include "DB_DAT.H"

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

#define CAT_NOMBRE 1
#define CAT_TABLA  2
#define CAT_RF     3
#define CAT_NR     4

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

int EligeTabla (DataBase Catalogo)
{
  int   i;
  int   tabla;
  int   tecla;
  char  cadena[80];
  Menu  MenuBDs   = CreaMenu();
  long  NumTablas = FichasBD(Catalogo);
  Ficha ficha;

  if (NumTablas>0) {

     for (i=1,tecla='A'; i<=NumTablas; i++,tecla++) {
	 ficha = CargaFicha(Catalogo,i);
	 CadenaCampo(ficha,CAT_NOMBRE,cadena);
	 OpcionMenu(MenuBDs,tecla,cadena);
	 LiberaFicha(&ficha);
     }

     tecla=EjecutaMenu(MenuBDs);

     if (tecla!=ESCAPE) {
	tabla = tecla-'A'+1;
     } else {
	tabla = 0;
     }

  } else {
     tabla = 0;
  }

  DestruyeMenu (&MenuBDs);

  return tabla;
}

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

int EligeCampo (DataBase BD)
{
  int   i;
  int   campo;
  int   tecla;
  Menu  MenuCampos = CreaMenu();

  if (CamposBD(BD)>0) {

     for (i=1,tecla='A'; i<=CamposBD(BD); i++,tecla++) {
	 OpcionMenu(MenuCampos,tecla,NombreCampo(BD,i));
     }

     tecla=EjecutaMenu(MenuCampos);

     if (tecla!=ESCAPE) {
	campo = tecla-'A'+1;
     } else {
	campo = 0;
     }

  } else {
     campo = 0;
  }

  DestruyeMenu (&MenuCampos);

  return campo;
}

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

void NuevoCampoCadena (DataBase BD, char *nombre)
{
  BYTE x,y;
  long max;

  GotoXY (19, 10);
  TextColor (CYAN);
  PrintF ("Longitud mxima permitida: ");
  TextColor (GRIS);
  max = 25;

  PosicionCursor(&x,&y);

  do {
      GotoXY(x,y);
      EditaEntero (&max);
  } while (max>=MAXCADENA || max<1);

  max++; /* '\0' */

  CampoCadena (BD, nombre, max);
}

/* --- */

void NuevoCampoEntero (DataBase BD, char *nombre)
{
  BYTE x,y;
  long min,max;

  GotoXY (19, 10);
  TextColor (CYAN);
  PrintF ("Valor mnimo permitido: ");
  TextColor (GRIS);
  min = 0;

  PosicionCursor(&x,&y);

  while (EditaEntero(&min)==ESCAPE) GotoXY (x,y);

  GotoXY (19, 13);
  TextColor (CYAN);
  PrintF ("Valor mximo permitido: ");
  TextColor (GRIS);
  max = min;

  PosicionCursor(&x,&y);

  do {
      while (EditaEntero(&max)==ESCAPE) GotoXY (x,y);
  } while (max<=min);

  CampoEntero (BD, nombre, min, max);
}

/* --- */

void NuevoCampoReal (DataBase BD, char *nombre)
{
  BYTE   x,y;
  double min,max;

  GotoXY (19, 10);
  TextColor (CYAN);
  PrintF ("Valor mnimo permitido: ");
  TextColor (GRIS);
  min = 0;

  PosicionCursor(&x,&y);

  while (EditaReal(&min)==ESCAPE) GotoXY (x,y);

  GotoXY (19, 13);
  TextColor (CYAN);
  PrintF ("Valor mximo permitido: ");
  TextColor (GRIS);
  max = min;

  PosicionCursor(&x,&y);

  do {
      while (EditaReal(&max)==ESCAPE) GotoXY (x,y);
  } while (max<=min);

  CampoReal (BD, nombre, min, max);
}

/* --- */

void NuevoCampoFecha (DataBase BD, char *nombre)
{
  BYTE x,y;
  long min,max;

  GotoXY (19, 10);
  TextColor (CYAN);
  PrintF ("Valor mnimo permitido: ");
  TextColor (GRIS);
  PosicionCursor(&x,&y);
  min = Hoy();
  do GotoXY (x,y);
  while (EditaFecha(&min)==ESCAPE);
  GotoXY (19, 13);
  TextColor (CYAN);
  PrintF ("Valor mximo permitido: ");
  TextColor (GRIS);
  PosicionCursor(&x,&y);
  max = Hoy();
  do GotoXY (x,y);
  while (EditaFecha(&max)==ESCAPE || max<=min);

  CampoFecha (BD, nombre, min, max);
}

/* --- */

void NuevoCampoMEMO (DataBase BD, char *nombre)
{
  BYTE x,y;
  char fichMEM[FICHERO];
  char fichNDX[FICHERO];

  GotoXY (19, 10);
  TextColor (CYAN);
  PrintF ("Fichero de datos del campo MEMO: ");
  TextColor (GRIS);
  PosicionCursor(&x,&y);
  while (LeeCadena(fichMEM,FICHERO)==ESCAPE) GotoXY (x,y);
  GotoXY (19, 13);
  TextColor (CYAN);
  PrintF ("Fichero ndice del campo MEMO:   ");
  TextColor (GRIS);
  PosicionCursor(&x,&y);
  while (LeeCadena(fichNDX,FICHERO)==ESCAPE) GotoXY (x,y);

  CampoMEMO (BD, nombre, fichMEM, fichNDX);
}

/* --- */

void NuevoCampoEnumerado (DataBase BD, char *nombre)
{
  BYTE x,y;
  char cadena[ENUMERADO];

  CampoEnumerado (BD, nombre);
  Presentacion ("Valores posibles del campo enumerado");
  GotoXY (1,3);
  TextColor (CYAN);
  PrintF ("Introduzca ahora los valores permitidos en este campo:");
  GotoXY (1,4);
  TextColor (AZUL);
  PrintF ("NOTA: Introduzca una lnea vaca para terminar");
  TextColor (GRIS);

  Ventana(1,11,80,23);

  do {

      PosicionCursor(&x,&y);

      do GotoXY(x,y);
      while (LeeCadena (cadena, ENUMERADO)==ESCAPE);

      PrintF ("\n");

      if (strcmp(cadena,""))
	 ValorCampoEnumerado (BD, CamposBD(BD), cadena);

  } while (strcmp(cadena,""));

  Ventana(1,6,80,23);
}

/* --- */

void NuevoCampoReferencia (DataBase BD, char *nombre, DataBase Catalogo)
{
  long     TablaReferenciada = EligeTabla(Catalogo);
  Ficha    Tabla;
  DataBase RefBD;
  int      campo;
  char     cadena[80];

  Tabla = CargaFicha(Catalogo,TablaReferenciada);

  CadenaCampo(Tabla,CAT_TABLA,cadena);
  RefBD = CargaBD(cadena);
  campo = EligeCampo(RefBD);
  LiberaBD(&RefBD);

  if (campo) {
     CadenaCampo(Tabla,CAT_TABLA,cadena);
     CampoReferencia(BD,nombre,cadena,campo);
  }

  LiberaFicha(&Tabla);
}

/* --- */

void NuevoCampo (DataBase BD, DataBase Catalogo)
{
  char nombre [CAMPO];
  int  tecla;
  BYTE x,y;
  Menu MenuTipoCampo = CreaMenu();

  OpcionMenu (MenuTipoCampo, 'C', "Cadena de caracteres");
  OpcionMenu (MenuTipoCampo, 'E', "Nmero entero");
  OpcionMenu (MenuTipoCampo, 'R', "Nmero real");
  OpcionMenu (MenuTipoCampo, 'F', "Fecha");
  OpcionMenu (MenuTipoCampo, 'M', "Campo MEMO");
  OpcionMenu (MenuTipoCampo, 'V', "Conjunto de valores");
  OpcionMenu (MenuTipoCampo, 'X', "Referencia");

  do {
     Presentacion ("Agregar campos a la estructura");
     tecla = EjecutaMenu (MenuTipoCampo);

     if (tecla!=ESCAPE) {

	switch (tecla) {

	  case 'C': Presentacion ("Nuevo campo de tipo cadena");
		    break;

	  case 'E': Presentacion ("Nuevo campo de tipo entero");
		    break;

	  case 'R': Presentacion ("Nuevo campo de tipo real");
		    break;

	  case 'F': Presentacion ("Nuevo campo de tipo fecha");
		    break;

	  case 'M': Presentacion ("Nuevo campo de tipo MEMO");
		    break;

	  case 'V': Presentacion ("Nuevo campo de tipo enumerado");
		    break;

	  case 'X': Presentacion ("Nuevo campo de tipo referencia");
		    break;
	}

	GotoXY (19, 5);
	TextColor (CYAN);
	PrintF ("Nombre del nuevo campo: ");
	TextColor (GRIS);
	PosicionCursor(&x,&y);

	while (LeeCadena (nombre, CAMPO)==ESCAPE)
	      GotoXY(x,y);

	switch (tecla) {

	  case 'C': NuevoCampoCadena(BD,nombre);
		    break;

	  case 'E': NuevoCampoEntero(BD,nombre);
		    break;

	  case 'R': NuevoCampoReal(BD,nombre);
		    break;

	  case 'F': NuevoCampoFecha(BD,nombre);
		    break;

	  case 'M': NuevoCampoMEMO(BD,nombre);
		    break;

	  case 'V': NuevoCampoEnumerado(BD,nombre);
		    break;

	  case 'X': NuevoCampoReferencia(BD,nombre,Catalogo);
		    break;
	}
     }
  } while (tecla!=ESCAPE);

  DestruyeMenu (&MenuTipoCampo);
}

/* ----------------------------------------------------------------------- */

void SuprimeCampo (DataBase BD)
{
  char OK[3];
  int  campo;

  Presentacion ("Eliminacin de campos");

  do {

      campo = EligeCampo(BD);

      if (campo) {
	 cls();
	 GotoXY (11, 10);
	 TextColor (CYAN);
	 PrintF (" Est seguro de querer eliminar el campo seleccionado ? ");
	 TextColor (GRIS);

	 strcpy (OK,"No");
	 EditaCadena (OK, 3);

	 if (!strcmp(strupr(OK),"S")||!strcmp(strupr(OK),"SI")) {
	    EliminaCampo (BD, campo);
	 }
      }

  } while (campo);

}

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

int ActualizaCatalogo ( DataBase Catalogo, DataBase BD, char *fichFRM)
{
  int   campo;
  int   errores = 0;
  char  cadena[80];
  long  ficha;
  long  TablasCatalogo = FichasBD(Catalogo);
  Ficha Tabla = CreaFicha(Catalogo);
  Ficha aux;

  strcpy( (char*)Campo(Tabla,CAT_NOMBRE), NombreBD(BD));
  strcpy( (char*)Campo(Tabla,CAT_TABLA), fichFRM);
  *(long*)Campo(Tabla,CAT_RF) = 0;
  *(long*)Campo(Tabla,CAT_NR) = 0;

  for (campo=1; campo<=CamposBD(BD); campo++) {

      if ( Tipo_Campo(BD,campo) == Referencia ) {

	 (*(long*)Campo(Tabla,CAT_RF))++;

	 if (TablasCatalogo) {
	    ficha=1;
	    aux=CargaFicha(Catalogo,ficha);
	    CadenaCampo(aux,CAT_TABLA,cadena);

	    while (  ficha<=TablasCatalogo
		  && strcmp( strupr(BDCampoReferencia(BD,campo)),
			     strupr(cadena) ) ) {
		  ficha++;
		  LiberaFicha(&aux);

		  if (ficha<=TablasCatalogo)
		     aux = CargaFicha(Catalogo,ficha);
	    }

	    if ( ficha<=TablasCatalogo ) {
	       (*(long*)Campo(aux,CAT_NR))++;
	       GuardaFicha(aux);
	       LiberaFicha(&aux);
	    } else
	       errores++;

	 } else errores++;

      }
  }

  if (!errores)
     GuardaFicha(Tabla);

  LiberaFicha(&Tabla);

  return errores;
}

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

void CreaBD_FRM (DataBase Catalogo)
{
  int      tecla;
  Menu     MenuFRM;

  DataBase BD;

  char nombre[DATABASE];
  char fichFRM[FICHERO];
  char fichDAT[FICHERO];

  Presentacion ("Creacin de bases de datos");

  GotoXY (1, 3);
  TextColor (CYAN);
  PrintF ("Nombre de la nueva base de datos:");
  TextColor (GRIS);
  GotoXY (1, 5);

  if (LeeCadena (nombre, DATABASE) != ESCAPE) {

     GotoXY (1, 8);
     TextColor (CYAN);
     PrintF ("Fichero de formato de la base de datos:");
     TextColor (GRIS);
     GotoXY (1, 10);

     if (LeeCadena (fichFRM, FICHERO) != ESCAPE) {

	GotoXY (1, 13);
	TextColor (CYAN);
	PrintF ("Fichero de datos de la base de datos:");
	TextColor (GRIS);
	GotoXY (1, 15);

	if (LeeCadena (fichDAT, FICHERO) != ESCAPE) {

	   BD = CreaBD (nombre, fichFRM, fichDAT);

	   MenuFRM = CreaMenu();
	   OpcionMenu (MenuFRM, 'A', "Aadir campos nuevos");
	   OpcionMenu (MenuFRM, 'B', "Borrar campos existentes");
	   OpcionMenu (MenuFRM, 'G', "Guardar estructura");

	   do {

	      Presentacion ("Edicin del formato de una base de datos");
	      tecla = EjecutaMenu(MenuFRM);

	      switch (tecla) {

		   case 'A': NuevoCampo (BD,Catalogo);
			     break;

		   case 'B': SuprimeCampo (BD);
			     break;

		   case 'G': if (CamposBD(BD)>0) {
				AlmacenaBD (BD);
				ActualizaCatalogo(Catalogo,BD,fichFRM);
			     }
			     break;
	      }

	   } while ((tecla!=ESCAPE)&&(tecla!='G'));

	   DestruyeMenu (&MenuFRM);
	   LiberaBD (&BD);
	}
     }
  }
}

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

void AgregaBD (DataBase Catalogo)
{
  int      errores;
  char     fichFRM[FICHERO];
  DataBase BD;

  Presentacion ("Aadir bases de datos");

  GotoXY (1, 7);
  TextColor (CYAN);
  PrintF ("Nombre del fichero de formato de la base de datos que desea aadir:");
  TextColor (GRIS);
  GotoXY (1, 9);

  if (LeeCadena (fichFRM, FICHERO) != ESCAPE) {

     if ((BD=CargaBD(fichFRM))!=NULL) {

	errores = ActualizaCatalogo(Catalogo,BD,fichFRM);
	LiberaBD (&BD);

	if (errores) {
	   cls();
	   GotoXY (4, 10);
	   TextColor (ROJO_INTENSO);
	   PrintF ("La tabla tiene referencias que no se corresponden con tablas del catlogo");
	   TextColor (GRIS);
	   Cursor(OCULTO);
	   while (GetChar()!=' ') ;
	   Cursor(VISIBLE);
	}

     } else {
	cls();
	GotoXY (20, 10);
	TextColor (ROJO_INTENSO);
	PrintF ("No se pudo encontrar la tabla especificada");
	TextColor (GRIS);
	Cursor(OCULTO);
	while (GetChar()!=' ') ;
	Cursor(VISIBLE);
     }
  }
}

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

int EliminaCatalogo ( DataBase Catalogo, long numero)
{
  int      campo;
  int      error = 0;
  char     cadena[80];
  long     ficha;
  long     TablasCatalogo = FichasBD(Catalogo);
  Ficha    Descripcion = CargaFicha(Catalogo,numero);
  Ficha    aux;

  DataBase BD;

  if (*(long*)Campo(Descripcion,CAT_NR)) {

     LiberaFicha(&Descripcion);

     error = 1;	/* Existen tablas con campos que referencian a esta tabla */

  } else {

     CadenaCampo(Descripcion,CAT_TABLA,cadena);
     BD = CargaBD(cadena);

     if (BD) for (campo=1; campo<=CamposBD(BD); campo++) {

	 if ( Tipo_Campo(BD,campo) == Referencia ) {

	    if (TablasCatalogo) {

	       ficha=1;
	       aux=CargaFicha(Catalogo,ficha);
	       CadenaCampo(aux,CAT_TABLA,cadena);

	       while (  ficha<=TablasCatalogo
		     && strcmp( strupr(BDCampoReferencia(BD,campo)),
				strupr(cadena) ) ) {
		     ficha++;
		     LiberaFicha(&aux);

		     if (ficha<=TablasCatalogo)
			aux = CargaFicha(Catalogo,ficha);
	       }

	       if ( ficha<=TablasCatalogo ) {
		  (*(long*)Campo(aux,CAT_NR))--;
		  GuardaFicha(aux);
		  LiberaFicha(&aux);
	       }
	    }
	 }
     }

     BorraFicha(&Descripcion);
     LiberaBD(&BD);
  }

  return error;
}


/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

void SuprimeBD (DataBase Catalogo)
{
  char     OK[3];
  int      Tabla;
  int      error;

  Presentacion ("Supresin de Bases de Datos");

  Tabla = EligeTabla(Catalogo);

  if (Tabla) {

     cls();
     GotoXY (7, 10);
     TextColor (CYAN);
     PrintF (" Est seguro de querer eliminar la base de datos seleccionada ? ");
     TextColor (GRIS);

     strcpy (OK,"No");
     EditaCadena (OK, 3);

     if (!strcmp(strupr(OK),"S")||!strcmp(strupr(OK),"SI")) {
	error = EliminaCatalogo(Catalogo, Tabla);

	if (error) {
	   cls();
	   GotoXY (6, 10);
	   TextColor (ROJO_INTENSO);
	   PrintF ("No se puede eliminar una tabla si tiene referencias que apuntan a ella");
	   TextColor (GRIS);
	   Cursor(OCULTO);
	   while (GetChar()!=' ') ;
	   Cursor(VISIBLE);
	}
     }
  }
}

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

DataBase AbreCatalogo (void)
{
  DataBase Catalogo = CreaBD("Catlogo","DBMS.FRM","DBMS.FBG");

  CampoCadena ( Catalogo, "Nombre", 60  );
  CampoCadena ( Catalogo, "Tabla",  60  );
  CampoEntero ( Catalogo, "RF", 0, 1000 );      /* Referencias de la tabla */
  CampoEntero ( Catalogo, "NR", 0, 1000 );      /* Referencias a la tabla  */

  return Catalogo;
}

/* ----------------------------------------------------------------------- */

void CierraCatalogo (DataBase *Catalogo)
{
  LiberaBD(Catalogo);
}

/* ----------------------------------------------------------------------- */

int main (void)
{
  int   tecla;

  DataBase Catalogo = AbreCatalogo();
  Menu     MenuPrincipal = CreaMenu();

  TipoDeLetra ("dbms_f1.fnt");

  OpcionMenu (MenuPrincipal, 'C', "Crear una nueva base de datos");
  OpcionMenu (MenuPrincipal, 'A', "Aadir bases de datos");
  OpcionMenu (MenuPrincipal, 'E', "Eliminar bases de datos");
  OpcionMenu (MenuPrincipal, 'S', "Salir del programa");


  do {

      Presentacion ("Gestor de bases de datos");
      tecla = EjecutaMenu (MenuPrincipal);

      switch (tecla) {

	 case 'C': CreaBD_FRM(Catalogo);
		   break;

	 case 'A': AgregaBD(Catalogo);
		   break;

	 case 'E': SuprimeBD(Catalogo);
		   break;
      }

  } while (tecla!='S');

  CierraCatalogo(&Catalogo);
  DestruyeMenu(&MenuPrincipal);
  Fin();
  TipoDeLetra ("dbms_f0.fnt");
  return 0;
}

/* ----------------------------------------------------------------------- */
