/* ----------------------------------------------------------------------- */
/*         Fernando Berzal Galiano       ETS Ingeniera Informtica        */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*      Funciones para el manejo de la estructura de una base de datos     */
/* ----------------------------------------------------------------------- */

char *NombreBD (DataBase BD);
int   CamposBD (DataBase BD);
long  FichasBD (DataBase BD);

/* ----------------------------------------------------------------------- */

char *NombreCampo (DataBase BD, int posicion);

/* ----------------------------------------------------------------------- */

TipoCampo Tipo_Campo (DataBase BD, int posicion);

/* ----------------------------------------------------------------------- */

int OffsetCampo (DataBase BD, int posicion);

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

int CheckCampoEntero (DataBase BD, int posicion, long valor);
int CheckCampoFecha (DataBase BD, int posicion, long valor);
int CheckCampoReal (DataBase BD, int posicion, double valor);

long MinCampoEntero (DataBase BD, int posicion);
long MaxCampoEntero (DataBase BD, int posicion);

long MinCampoFecha (DataBase BD, int posicion);
long MaxCampoFecha (DataBase BD, int posicion);

double MinCampoReal (DataBase BD, int posicion);
double MaxCampoReal (DataBase BD, int posicion);

int LongitudCampoCadena (DataBase BD, int posicion);

Lista ValoresCampoEnumerado  (DataBase BD, int posicion);
int   CardinalCampoEnumerado (DataBase BD, int posicion);

char *FicheroCampoMEMO (DataBase BD, int posicion);
char *IndiceCampoMEMO  (DataBase BD, int posicion);

char *BDCampoReferencia (DataBase BD, int posicion);
int   PKCampoReferencia (DataBase BD, int posicion);

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

void EliminaCampo (DataBase BD, int posicion);

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

void CampoEntero ( DataBase BD, char *nombre, long min, long max);

void CampoReal ( DataBase BD, char *nombre, double min, double max);

void CampoEnumerado      (DataBase BD, char *nombre);
void ValorCampoEnumerado (DataBase BD, int posicion, char *valor);

void CampoCadena ( DataBase BD, char *nombre, int longitud );

void CampoFecha ( DataBase BD, char *nombre, long min, long max );

void CampoMEMO ( DataBase BD, char *nombre, char *fMEM, char *fNDX );

void CampoReferencia ( DataBase BD, char *nombre, char *RefBD, int RefPK );

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

DataBase CreaBD ( char *nombre, char *fichFormato, char *fichDatos );

/* ----------------------------------------------------------------------- */

void LiberaBD (DataBase *BD);

/* ----------------------------------------------------------------------- */
/*        Volcado del formato de la base de datos a/desde un fichero       */
/* ----------------------------------------------------------------------- */
/*                                                                         */
/*  Fichero de formato:                                                    */
/*                                                                         */
/*    HEADER = DBMS FBGVG                                                  */
/*    Nombre del fichero de datos                                          */
/*    Nombre de la base de datos                                           */
/*    Nmero de campos                                                     */
/*    Lista de campos                                                      */
/*                                                                         */
/*   CAMPO:                                                                */
/*    Nombre del campo                                                     */
/*    Tipo del campo                                                       */
/*    Especificaciones                                                     */
/*                                                                         */
/*   Entero:                                                               */
/*    Mnimo                                                               */
/*    Mximo                                                               */
/*   Fecha:                                                                */
/*    Mnimo                                                               */
/*    Mximo                                                               */
/*   Real:                                                                 */
/*    Mnimo                                                               */
/*    Mximo                                                               */
/*   Cadena:                                                               */
/*    Longitud permitida                                                   */
/*   MEMO:                                                                 */
/*    Fichero de datos del campo MEMO                                      */
/*    Fichero ndice del campo MEMO                                        */
/*   Enumerado:                                                            */
/*    Nmero de valores                                                    */
/*    Lista de valores permitidos                                          */
/*   Referencia:                                                           */
/*    Tabla referenciada                                                   */
/*    Posicin de la "PK" de la tabla referenciada                         */
/* ----------------------------------------------------------------------- */

void AlmacenaBD (DataBase DB);

/* ----------------------------------------------------------------------- */

DataBase CargaBD ( char *fichero );

/* ----------------------------------------------------------------------- */
