/* ----------------------------------------------------------------------- */
/*    Fernando Berzal Galiano                ETS Ingeniera Informtica    */
/* ----------------------------------------------------------------------- */
/*                      Pantalla: Modo de vdeo 03h                        */
/*                              Watcom C++                                 */
/* ----------------------------------------------------------------------- */

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>

#include <i86.h>
#include <dos.h>
#include <graph.h>
#include <conio.h>

#include "FBG_CRT.H"

/* ----------------------------------------------------------------------- */

BYTE PaginaActiva = 0;          /* Pgina activa               */

BYTE Atributos = 0x07;          /* Atributos de los caracteres */

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*  Inicializacin                                                         */
/* ----------------------------------------------------------------------- */

void ModoTexto (void)
{
  _setvideomode (3);               /* Modo de vdeo 0x03: Modo texto 80x25 */

  TextColor(GRIS);
  TextBackground(NEGRO);
  Parpadeo(OFF);
  Pagina(0);
  Ventana(1,1,80,25);
}

/* ----------------------------------------------------------------------- */
/*  Pgina: 8 pginas de texto disponibles                                 */
/* ----------------------------------------------------------------------- */

void Pagina (BYTE numero)
{
  _setactivepage (numero);
  _setvisualpage (numero);

  PaginaActiva = numero;
}

/* ----------------------------------------------------------------------- */

void PushPagina (void)
{
  if (PaginaActiva<7) {
     Pagina (PaginaActiva+1);
     Ventana (1,1,80,25);
     TextColor(GRIS);
     TextBackground(NEGRO);
     Parpadeo(OFF);
     cls();
  }
}

/* ----------------------------------------------------------------------- */

void PopPagina (void)
{
  if (PaginaActiva>0)
     Pagina (PaginaActiva-1);
}


/* ----------------------------------------------------------------------- */
/*  Ventana activa                                                         */
/* ----------------------------------------------------------------------- */

void Ventana (BYTE Xmin, BYTE Ymin, BYTE Xmax, BYTE Ymax)
{
  _settextwindow (Ymin,Xmin,Ymax,Xmax);

  GotoXY (1,1);
}

/* ----------------------------------------------------------------------- */

void VentanaActual (BYTE *Xmin, BYTE *Ymin, BYTE *Xmax, BYTE *Ymax)
{
  short x1, x2, y1, y2;

  _gettextwindow ( &y1, &x1, &y2, &x2);

  *Xmin = x1;
  *Ymin = y1;
  *Xmax = x2;
  *Ymax = y2;
}

/* ----------------------------------------------------------------------- */

void cls (void)
{
  _clearscreen(_GWINDOW);
  GotoXY(1,1);
}

/* ----------------------------------------------------------------------- */

void clrLine (void)
{
  BYTE x1,x2,y1,y2,x,y;

  PosicionCursor(&x,&y);
  VentanaActual(&x1,&y1,&x2,&y2);
  Ventana(x1,y1+y-1,x2,y1+y-1);
  _clearscreen(_GWINDOW);  		//  ScrollDown(1);
  Ventana(x1,y1,x2,y2);
  GotoXY(x,y);
}

/* ----------------------------------------------------------------------- */
/*  Cursor                                                                 */
/* ----------------------------------------------------------------------- */

void PosicionCursor (BYTE *x, BYTE *y)
{
  struct rccoord pos = _gettextposition();

  *x = pos.col;
  *y = pos.row;
}

/* ----------------------------------------------------------------------- */

void GotoXY (BYTE x, BYTE y)
{
  _settextposition (y, x);
}

/* ----------------------------------------------------------------------- */

void Cursor (WORD Forma)
{
  /* Cambia el aspecto del cursor */

  _settextcursor (Forma);

}

/* ----------------------------------------------------------------------- */

WORD EstadoCursor (void)
{
  /* Obtiene el aspecto del cursor */

  return _gettextcursor();
}


/* ----------------------------------------------------------------------- */
/*  Colores                                                                */
/* ----------------------------------------------------------------------- */

void TextColor (BYTE color)
{
  Atributos = (Atributos&0xF0) | (color&0x0F);

  if (Atributos&0x80)
     _settextcolor ( (color&0x0F)|0x10 );
  else
     _settextcolor ( color&0x0F );
}

/* ----------------------------------------------------------------------- */

void TextBackground (BYTE color)
{
  Atributos = (Atributos&0x8F) | ((color&0x07)<<4);

  _setbkcolor ( color&0x07 );
}

/* ----------------------------------------------------------------------- */

void Parpadeo (BYTE flag)
{
  if (flag) {
     Atributos = Atributos | 0x80;
     _settextcolor ( (Atributos&0x0F)|0x10 );
  } else {
     Atributos = Atributos & 0x7F;
     _settextcolor ( Atributos&0x0F );
  }
}

/* ----------------------------------------------------------------------- */
/*  Scroll                                                                 */
/* ----------------------------------------------------------------------- */

void ScrollUp (BYTE Lineas)
{
  _scrolltextwindow (Lineas);
}

/* ----------------------------------------------------------------------- */

void ScrollDown (BYTE Lineas)
{
  _scrolltextwindow (-Lineas);
}

/* ----------------------------------------------------------------------- */
/*  Salida de caracteres                                                   */
/* ----------------------------------------------------------------------- */

#define BELL  7
#define BS    8
#define TAB   9
#define LF   10
#define FF   12
#define CR   13

void PutChar (BYTE caracter)
{
  PrintF ("%c",caracter);
}

/* ----------------------------------------------------------------------- */
/*  printf                                                                 */
/* ----------------------------------------------------------------------- */

void PrintF ( char * string, ... )
{
  va_list param;
  char    salida[255];
  char   *cp;

  va_start ( param, string );
  vsprintf ( salida, string, param );

  _outtext ( salida );

  va_end (param);
}

/* ----------------------------------------------------------------------- */
/*  Tipos de letra                                                         */
/* ----------------------------------------------------------------------- */

// char buffer[4096];

void TipoDeLetra (const char *fichero)
{
  // union REGPACK Registros;
  // char *p;
  // FILE *fich;
  // int   ch;

  // if ((fich=fopen(fichero,"rb"))!=NULL) {

  //    for ( p=buffer; (ch=fgetc(fich))!=EOF ; p++)
  //        *p=ch;

  //    fclose(fich);

  //    Registros.w.ax = 0x1100;
  //    Registros.w.bx = 0x1000;
  //    Registros.w.cx = 0x00FF;
  //    Registros.w.dx = 0x0000;
  //    Registros.w.es = FP_SEG (buffer);
  //    Registros.w.bp = FP_OFF (buffer);

  //    intr ( 0x10, &Registros );     /* Interrupcin de vdeo de la BIOS */
  // }
}

/* ----------------------------------------------------------------------- */
/*  Presentacin                                                           */
/* ----------------------------------------------------------------------- */

void Presentacion (char *nombre)
{
  TextColor (GRIS);
  TextBackground ( NEGRO );
  cls();
  Ventana ( 18, 2, 65, 4 );
  TextBackground ( CYAN );
  cls();
  Ventana ( 16, 1, 63, 3 );
  TextBackground ( AZUL );
  cls();
  GotoXY ( 24-(strlen(nombre)/2), 2 );
  PrintF("%s",nombre);
  Ventana ( 1, 25, 80, 25 );
  TextBackground ( AZUL );
  cls();
  PrintF("           Fernando Berzal Galiano         ETS Ingeniera Informtica");
  TextBackground ( NEGRO );
  Ventana ( 1, 6, 80, 23 );
  cls();
}

/* ----------------------------------------------------------------------- */

void Fin(void)
{
  Ventana (1, 1, 80, 25);
  TextColor (GRIS);
  TextBackground(NEGRO);
  cls();
}

/* ----------------------------------------------------------------------- */
