/* ----------------------------------------------------------------------- */
/*    Fernando Berzal Galiano                ETS Ingeniera Informtica    */
/* ----------------------------------------------------------------------- */
/*                           Modo de vdeo 03h                             */
/*                               Watcom C++                                */  
/* ----------------------------------------------------------------------- */

#ifndef BYTE
#define BYTE unsigned char
#endif

#ifndef WORD
#define WORD unsigned short
#endif

/* ----------------------------------------------------------------------- */

#ifndef __FBG_CRT__
#define __FBG_CRT__

/* ----------------------------------------------------------------------- */

/* Nmero de espacios de un tabulador */

#define TABULADOR 8

/* Aspecto del cursor */

#define VISIBLE 0x0D0E
#define OCULTO  0x2000
#define MEDIANO 0x050E
#define GRANDE  0x010F

/* Colores */

#define NEGRO           0x00
#define AZUL            0x01
#define VERDE           0x02
#define CYAN            0x03
#define ROJO            0x04
#define VIOLETA         0x05
#define MARRON          0x06
#define GRIS            0x07
#define GRIS_OSCURO     0x08
#define AZUL_CLARO      0x09
#define VERDE_CLARO     0x0A
#define CELESTE         0x0B
#define ROJO_INTENSO    0x0C
#define ROSA            0x0D
#define AMARILLO        0x0E
#define BLANCO          0x0F

/* Parpadeo */

#define ON              1
#define OFF             0

/* ----------------------------------------------------------------------- */
/*  Inicializacin                                                         */
/* ----------------------------------------------------------------------- */

void ModoTexto (void);

/* ----------------------------------------------------------------------- */
/*  Pgina: 8 pginas de texto disponibles                                 */
/* ----------------------------------------------------------------------- */

void Pagina (BYTE numero);

/* ----------------------------------------------------------------------- */

void PushPagina (void);

/* ----------------------------------------------------------------------- */

void PopPagina (void);

/* ----------------------------------------------------------------------- */
/*  Ventana activa                                                         */
/* ----------------------------------------------------------------------- */

void Ventana (BYTE Xmin, BYTE Ymin, BYTE Xmax, BYTE Ymax);

void VentanaActual (BYTE *Xmin, BYTE *Ymin, BYTE *Xmax, BYTE *Ymax);

/* ----------------------------------------------------------------------- */

void cls (void);

void clrLine (void);

/* ----------------------------------------------------------------------- */
/*  Scroll                                                                 */
/* ----------------------------------------------------------------------- */

void ScrollUp (BYTE Lineas);

/* ----------------------------------------------------------------------- */

void ScrollDown (BYTE Lineas);

/* ----------------------------------------------------------------------- */
/*  Cursor                                                                 */
/* ----------------------------------------------------------------------- */

void PosicionCursor (BYTE *x, BYTE *y);

/* ----------------------------------------------------------------------- */

void GotoXY (BYTE x, BYTE y);

/* ----------------------------------------------------------------------- */

void Cursor (WORD Forma);

/* ----------------------------------------------------------------------- */

WORD EstadoCursor (void);

/* ----------------------------------------------------------------------- */
/*  Colores                                                                */
/* ----------------------------------------------------------------------- */

void TextColor (BYTE color);

/* ----------------------------------------------------------------------- */

void TextBackground (BYTE color);

/* ----------------------------------------------------------------------- */

void Parpadeo (BYTE flag);

/* ----------------------------------------------------------------------- */
/*  Salida de caracteres                                                   */
/* ----------------------------------------------------------------------- */

void PutChar (BYTE caracter);

/* ----------------------------------------------------------------------- */
/*  printf                                                                 */
/* ----------------------------------------------------------------------- */

void PrintF ( char * string, ... );

/* ----------------------------------------------------------------------- */
/*  Tipos de letra                                                         */
/* ----------------------------------------------------------------------- */

void TipoDeLetra (const char *fichero);

/* ----------------------------------------------------------------------- */
/*  Presentacin                                                           */
/* ----------------------------------------------------------------------- */

void Presentacion (char *nombre);

/* ----------------------------------------------------------------------- */

void Fin(void);

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */

#endif
