/* ----------------------------------------------------------------------- */
/*    Fernando Berzal Galiano                ETS Ingeniera Informtica    */
/* ----------------------------------------------------------------------- */
/*                               Teclado                                   */
/* ----------------------------------------------------------------------- */

#include <i86.h>
#include <conio.h>

#include "FBG_KBD.H"

/* ----------------------------------------------------------------------- */

BYTE FlagCodigoAmpliado = 0;

BYTE GetChar (void)
{
  BYTE caracter;

  if (FlagCodigoAmpliado) {

     caracter           = FlagCodigoAmpliado;
     FlagCodigoAmpliado = 0;

  } else {

     caracter = getch();

     if (caracter==0)
        FlagCodigoAmpliado = getch();
  }

  return caracter;
}

/* ----------------------------------------------------------------------- */

int TeclaPulsada (void)
{
  return (kbhit());
}

/* ----------------------------------------------------------------------- */

WORD EstadoTeclado (void)
{
  union REGS regs;

  regs.h.ah = 0x12;

  int386 (0x16, &regs, &regs);
  
  return (regs.w.ax);
}

/* --- */

int Shift (void)
{
  return ((EstadoTeclado()&0x03)!=0);
}

int LeftShift (void)
{
  return ((EstadoTeclado()&0x02)!=0);
}

int RightShift (void)
{
  return ((EstadoTeclado()&0x01)!=0);
}

int Control (void)
{
  return ((EstadoTeclado()&0x04)!=0);
}

int LeftControl (void)
{
  return ((EstadoTeclado()&0x0100)!=0);
}

int RightControl (void)
{
  return ((EstadoTeclado()&0x0400)!=0);
}

int Alt (void)
{
  return ((EstadoTeclado()&0x08)!=0);
}

int LeftAlt (void)
{
  return ((EstadoTeclado()&0x0200)!=0);
}

int RightAlt (void)
{
  return ((EstadoTeclado()&0x0800)!=0);
}

/* ----------------------------------------------------------------------- */

int ScrollLock (void)
{
  return ((EstadoTeclado()&0x10)!=0);
}

int NumLock (void)
{
  return ((EstadoTeclado()&0x20)!=0);
}

int CapsLock (void)
{
  return ((EstadoTeclado()&0x40)!=0);
}

/* ----------------------------------------------------------------------- */

#define CAPS_LOCK    64
#define NUM_LOCK     32
#define SCROLL_LOCK  16

#define BIOS_KBF *((unsigned short far *)MK_FP(0x40,0x17))

void SetLED (BYTE flag)
{
  BIOS_KBF |= flag;
}

void ClearLED (BYTE flag)
{
  BIOS_KBF &= !flag;
}

/* ----------------------------------------------------------------------- */

void AnulaBufferTeclado (void)
{
 _disable();
 *(WORD far *)MK_FP(0x40,0x1a) = *(WORD far *)MK_FP(0x40,0x1c);
 _enable();
}

/* ----------------------------------------------------------------------- */
