/* -------------------------------------------------------------- */
/*    Fernando Berzal Galiano        1 Ingeniera Informtica    */
/* -------------------------------------------------------------- */
/*    TDA Lista doblemente enlazada circular con nodo cabecera    */
/* -------------------------------------------------------------- */

#ifndef __FB_LISTAS__

#define __FB_LISTAS__

/* -------------------------------------------------------------- */
/*                     Declaracin de tipos                       */
/* -------------------------------------------------------------- */

typedef struct nodo {
		     struct nodo *anterior;
		     struct nodo *siguiente;
		     void *info;
		    } InfoNodo;

typedef struct NodoLista {
			  struct nodo *cabecera;
			  int size;
			 } InfoLista;

typedef InfoNodo  *Nodo;

typedef InfoLista *Lista;

/* ------------------------------------------------------------- */
/*                  Declaracin de Primitivas                    */
/* ------------------------------------------------------------- */

Lista CreaLista (int size);

/*  Crea la estructura de la lista y la deja lista para comenzar */
/* a trabajar con ella. Devuelve NULL si no encuentra la memoria */
/* suficiente.                                                   */

/* ------------------------------------------------------------- */

int ListaVacia (Lista l);

/* Indica si la lista est vaca o no                            */

/* ------------------------------------------------------------- */

Nodo InicioLista (Lista l);

/* Devuelve la posicin del primer elemento de la lista          */

/* ------------------------------------------------------------- */

Nodo UltimoLista (Lista l);

/* Devuelve la posicin del ltimo elemento de la lista          */

/* ------------------------------------------------------------- */

Nodo FinLista (Lista l);

/*   Devuelve la posicin del final de la lista (donde se aaden */
/* nuevos datos, la posicin siguiente al ltimo elemento).      */

/* ------------------------------------------------------------- */

void BorraNodoLista (Lista l, Nodo elemento);

/* Elimina el nodo de la lista apuntado por elemento             */

/* ------------------------------------------------------------- */

void DestruyeLista (Lista *l);

/* Elimina la lista y libera la memoria                          */

/* ------------------------------------------------------------- */

int InsertaNodoLista (Lista l, Nodo pos, void *dato);

/*     Inserta un nuevo elemento en la lista, en la posicin del */
/* elemento apuntado por 'pos' (su contenido ser 'dato').       */

/* ------------------------------------------------------------- */

void *LeeNodoLista (Lista l, Nodo elemento);

/*    Lee el dato almacenado en la lista en la posicin indicada */
/* por 'elemento'.  El dato se devuelve como salida.             */

/* ------------------------------------------------------------- */

Nodo SiguienteLista (Lista l, Nodo elemento);

/* Devuelve la posicin del elemento siguiente al elemento apun- */
/* tado por el segundo parmetro. Devuelve NULL si 'elemento' es */
/* el final de la lista (considerada lineal).                    */

/* ------------------------------------------------------------- */

Nodo SiguienteListaCircular (Lista l, Nodo elemento);

/*   Como la funcin anterior, salvo que la lista es considerada */
/* circular (por lo que todo elemento tiene siguiente).          */

/* ------------------------------------------------------------- */

Nodo AnteriorLista (Lista l, Nodo elemento);

/* Devuelve el elemento anterior en la lista, considerada lineal */
/* (devuelve 'NULL' si se intenta acceder al anterior del primer */
/* elemento de la lista).                                        */

/* ------------------------------------------------------------- */

Nodo AnteriorListaCircular (Lista l, Nodo elemento);

/* Devuelve el elemento anterior en la lista, considerndola ce- */
/* rrada (circular): todo elemento tiene anterior.               */

/* ------------------------------------------------------------- */

#endif